using LitJson;
using System;
using System.Collections.Generic;
using System.Linq;
using UnityEditor;
using UnityEngine;
using WS;

public class InteractObjsOperateEditor : IOperateEditor
{
    public string Name => "彻";

    public Type Component => typeof(InteractObjsComponent);

    ///<summary>ģʽ</summary>
    private string[] Models = new string[] { "", "+" };
    ///<summary>ģʽ</summary>
    private int ModelIndex;
    ///<summary></summary>
    private GameObject InteractObj;
    ///<summary>жƬ</summary>
    private string[] AnimationNames;
    ///<summary>ѡ񲥷Ŷ</summary>
    private int AnimationIndex;

    ///<summary>Ƿй</summary>
    private bool IsDependence;
    ///<summary>Ӧб</summary>
    private List<AnswerObjs> AnswerObjList = new List<AnswerObjs>();
    ///<summary> ۵ </summary>
    private bool foldout;

    InteractObjsData Data;
    public void Dispose()
    {
        
    }

    public void Init(string json)
    {
        Data = string.IsNullOrEmpty(json) ? new InteractObjsData() : JsonMapper.ToObject<InteractObjsData>(json);
        if (!string.IsNullOrEmpty(Data.InteractName))
        {
            InteractObj = GameObject.Find(Data.InteractName);
            if (InteractObj == null)
            {
                Debug.Log($"ڳδҵ {Data.InteractName} ,!");
                return;
            }
            if (!string.IsNullOrEmpty(Data.AnimationName))
            {
                Animator animator = InteractObj.transform.GetComponent<Animator>();
                if (animator != null)
                {
                    List<string> list = animator.runtimeAnimatorController.animationClips.Select(a => a.name).ToList();
                    AnimationIndex = list.FindIndex(s => s == Data.AnimationName);
                    if (AnimationIndex < 0)
                        AnimationIndex = 0;
                    AnimationNames = list.ToArray();
                }
                ModelIndex = 1;
            }
        }

        for (int i = 0; i < Data.AnswerObjDataList.Count; i++)
        {
            if (!string.IsNullOrEmpty(Data.AnswerObjDataList[i].AnswerName))
            {
                AnswerObjs answerObjs = new AnswerObjs();
                answerObjs.AnswerObj = GameObject.Find(Data.AnswerObjDataList[i].AnswerName);
                if (answerObjs.AnswerObj == null)
                {
                    Debug.Log($"ڳδҵ {Data.AnswerObjDataList[i].AnswerName} ,!");
                    return;
                }
                if (!string.IsNullOrEmpty(Data.AnswerObjDataList[i].AnswerAnimName))
                {
                    Animator animator = answerObjs.AnswerObj.transform.GetComponent<Animator>();
                    if (animator != null)
                    {
                        List<string> list = animator.runtimeAnimatorController.animationClips.Select(a => a.name).ToList();
                        answerObjs.AnswerAnimIndex = list.FindIndex(s => s == Data.AnswerObjDataList[i].AnswerAnimName);
                        if (answerObjs.AnswerAnimIndex < 0)
                            answerObjs.AnswerAnimIndex = 0;
                        answerObjs.AnswerAnimNames = list.ToArray();
                    }
                    IsDependence = true;
                }
                AnswerObjList.Add(answerObjs);
            }
        }
    }

    public void OnGUI()
    {
        EditorGUILayout.BeginHorizontal();
        GUILayout.Label(":", GUILayout.Width(55));
        IsDependence = EditorGUILayout.Toggle(IsDependence);
        GUILayout.Label("ǰʾ:", GUILayout.Width(95));
        Data.BeforeEnable = EditorGUILayout.Toggle(Data.BeforeEnable);
        GUILayout.Label("Ƿڲ:", GUILayout.Width(115));
        Data.InteractInside = EditorGUILayout.Toggle(Data.InteractInside);
        GUILayout.Label("ģʽ:", GUILayout.Width(35));
        ModelIndex = EditorGUILayout.Popup(ModelIndex, Models, GUILayout.Width(300));
        EditorGUILayout.EndHorizontal();

        EditorGUILayout.BeginHorizontal();
        GUILayout.Label("Ƶ:", GUILayout.Width(35));
        Data.AudioName = EditorGUILayout.TextField(Data.AudioName);

        GUILayout.Label("Ч:", GUILayout.Width(35));
        Data.AudioEffect = EditorGUILayout.TextField(Data.AudioEffect);
        GUILayout.Label("ĸ:", GUILayout.Width(110));
        InteractObj = (GameObject)EditorGUILayout.ObjectField(InteractObj, typeof(GameObject), true);


        if (ModelIndex == 1)
        {
            if (InteractObj != null)
            {
                if (InteractObj.transform.childCount <= 0)
                {
                    Debug.Log($"{InteractObj.name}ûпɽ");
                }
                if (AnimationNames == null)
                {
                    Animator animator = InteractObj.transform.GetComponent<Animator>();
                    if (animator != null)
                        AnimationNames = animator.runtimeAnimatorController.animationClips.Select(a => a.name).ToArray();
                }
                if (AnimationNames != null)
                {
                    GUILayout.Label(":", GUILayout.Width(35));
                    AnimationIndex = EditorGUILayout.Popup(AnimationIndex, AnimationNames);
                }
            }
        }
        EditorGUILayout.EndHorizontal();

        if (IsDependence)
        {
            foldout = EditorGUILayout.BeginFoldoutHeaderGroup(foldout, "б:");
            if (foldout)
            {
                for (int i = 0; i < AnswerObjList.Count; i++)
                {
                    EditorGUILayout.BeginHorizontal();
                    AnswerObjList[i].AnswerObj = (GameObject)EditorGUILayout.ObjectField(AnswerObjList[i].AnswerObj, typeof(GameObject), true);

                    if (AnswerObjList[i].AnswerObj != null)
                    {
                        if (AnswerObjList[i].AnswerAnimNames == null)
                        {
                            Animator animator = AnswerObjList[i].AnswerObj.transform.GetComponent<Animator>();
                            if (animator != null)
                                AnswerObjList[i].AnswerAnimNames = animator.runtimeAnimatorController.animationClips.Select(a => a.name).ToArray();
                        }
                        if (AnswerObjList[i].AnswerAnimNames != null)
                        {
                            GUILayout.Label(":", GUILayout.Width(35));
                            AnswerObjList[i].AnswerAnimIndex = EditorGUILayout.Popup(AnswerObjList[i].AnswerAnimIndex, AnswerObjList[i].AnswerAnimNames);
                        }
                    }
                    EditorGUILayout.EndHorizontal();
                }

                EditorGUILayout.BeginHorizontal();
                if (GUILayout.Button(""))
                {
                    AnswerObjList.Add(new AnswerObjs());
                }
                if (GUILayout.Button("Ƴ"))
                {
                    if (AnswerObjList.Count > 0)
                    {
                        AnswerObjList.Remove(AnswerObjList[AnswerObjList.Count - 1]);
                    }
                }
                EditorGUILayout.EndHorizontal();
            }
            EditorGUILayout.EndFoldoutHeaderGroup();
        }
    }

    public string ToData()
    {
        Data.InteractName = InteractObj != null ? EditorHelper.GetTransformParentPath(InteractObj.transform) : "";
        if (AnimationNames != null)
            Data.AnimationName = ModelIndex == 1 ? AnimationNames[AnimationIndex] : "";

        Data.AnswerObjDataList.Clear();
        for (int i = 0; i < AnswerObjList.Count; i++)
        {
            AnswerObjData answerObj = new AnswerObjData();
            answerObj.AnswerName = AnswerObjList[i].AnswerObj != null ? EditorHelper.GetTransformParentPath(AnswerObjList[i].AnswerObj.transform) : "";
            if (AnswerObjList[i].AnswerAnimNames != null && IsDependence)
            {
                answerObj.AnswerAnimName = AnswerObjList[i].AnswerAnimNames[AnswerObjList[i].AnswerAnimIndex];
            }
            Data.AnswerObjDataList.Add(answerObj);
        }
        return JsonMapper.ToJson(Data);
    }
}
