using LitJson;
using System;
using UnityEditor;
using UnityEngine;
using UnityEngine.SceneManagement;
using WS;

public class LoadSceneOperateEditor : IOperateEditor
{
    public string Name => "س";
    /// <summary> ͵ </summary>
    private GameObject transferPoint;
    public Type Component => typeof(LoadSceneComponent);
    private LoadSceneData Data;

    public void Dispose()
    {
        
    }

    public void Init(string json)
    {
        Data = string.IsNullOrEmpty(json) ? new LoadSceneData() : JsonMapper.ToObject<LoadSceneData>(json);
        if (!string.IsNullOrEmpty(Data.transferPoint))
        {
            transferPoint = GameObject.Find(Data.transferPoint);

            if (transferPoint == null)
            {
                Debug.Log($"ڳδҵ {Data.transferPoint} ,!");

                return;
            }

        }
    }

    public void OnGUI()
    {      
        EditorGUILayout.BeginHorizontal();
        GUILayout.Label("ʼ:", GUILayout.Width(85));
        Data.startSceneName = (SceneName)EditorGUILayout.EnumPopup(Data.startSceneName);
        GUILayout.Label("Ŀ곡:", GUILayout.Width(85));
        Data.endSceneName = (SceneName)EditorGUILayout.EnumPopup(Data.endSceneName);
        EditorGUILayout.EndHorizontal();

        EditorGUILayout.BeginHorizontal();
        GUILayout.Label("Ƶ:", GUILayout.Width(55));
        Data.AudioName = EditorGUILayout.TextField(Data.AudioName);
        GUILayout.Label("غλõ:", GUILayout.Width(95));
        transferPoint = (GameObject)EditorGUILayout.ObjectField(transferPoint, typeof(GameObject), true);
        if(transferPoint != null)
        {
            Data.pos = transferPoint.transform.position;
            Data.rot = transferPoint.transform.localRotation.eulerAngles;
        }

        EditorGUILayout.EndHorizontal();
    }

    public string ToData()
    {
        if (Data.AudioName != null)
        {
            Data.AudioName = Data.AudioName.Replace(" ", "");
        }
        Data.transferPoint = transferPoint != null ? EditorHelper.GetTransformParentPath(transferPoint.transform) : "";
        return JsonMapper.ToJson(Data);
    }
}
