using System.Collections.Generic;
using UnityEngine;
using WS;

[ObjectSystem]
public class DataManagerAwakeSystem : AwakeSystem<DataManager>
{
    public override void Awake(DataManager self)
    {
        self.Awake();
    }
}

///<summary>数据管理器</summary>
public class DataManager : WSComponent
{
    ///<summary>用户数据</summary>
    public UserData User;
    ///<summary>模式</summary>
    public PatternType Pattern;

    ///<summary>是否引导</summary>
    public bool IsGuide { get; set; }
    ///<summary>位置</summary>
    public Vector3 pos;
    ///<summary>旋转</summary>
    public Quaternion rot;
    ///<summary>课程</summary>
    public List<CourseData> Courses;

    public string httpBase = "http://dgs.admin.intatc.com/";



    public void Awake()
    {
        Courses = ConfigHelper.LoadConfig<List<CourseData>>($"Config/Framework/Course");


    }
}

///<summary>课程数据</summary>
public class LoadScenePoint
{

}
///<summary>课程数据</summary>
public class CourseData
{
    public string Name;
}