
using System;
using System.Collections.Generic;
using Unity.VisualScripting;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.EventSystems;
using UnityEngine.UI;

using static ScrollViewUI.ScrollCycleView;

namespace ScrollViewUI
{

    public class ScrollCycleView
    {
        public enum DragType
        {
            Vertical,
            Horizontal

        }

        public class ItemData
        {


            public GameObject go;
            public RectTransform tran;
            public bool isActive;
        }

        public GameObject gameObject;
        /// <summary>
        ///  rtf ؼ
        /// </summary>
        public RectTransform rectTransform;
        /// <summary>
        /// ϶ ui tf;
        /// </summary>
        public RectTransform dragGOTran;

        /// <summary>
        /// ƶ
        /// </summary>
        public UITweenSpring moveTween;

        public EventTrigger trigger;


        /// <summary>
        /// -϶ȣԽԽ
        /// </summary>
        public float speed = 1;

        /// <summary>
        /// ԽԽ
        /// </summary>
        public float resistance = 1;

        /// <summary>
        /// ֳ֧϶
        /// </summary>
        public bool elastic = true;




        #region OnOpen
        public Scrollbar scrollBar;

        /// <summary>
        /// itemĴС
        /// </summary>
        public Vector2 cellSize;
        public GameObject item;
        /// <summary>
        /// itemĿȼ ȼ
        /// </summary>
        public float itemWidth;
        /// <summary>
        /// itemĸ߶ȼ ߶ȶȼ
        /// </summary>
        public float itemHeight;

        /// <summary>
        /// 
        /// </summary>
        public DragType dragType;
        /// <summary>
        /// ԶŲ Ļб ͱʾ  ŷŶٸ  Ļб ͬ
        /// </summary>
        public int fixedCount;
        /// <summary>
        ///   ʱ      һܷ  itemĬ+1ʾʾȫһܹʱ©ա  Ļͬ
        /// </summary>
        public int itemCount;
        /// <summary>
        /// ң¼
        /// </summary>
        public Vector2 spacing;

        /// <summary>
        ///  Ļб ͱʾ yֵΪ  itemCount* itemHeight һ ռ೤ xֵΪ0. Ļͬ
        /// </summary>
        public Vector2 offsetV2;


        public List<GameObject> goItemList = new List<GameObject>();
        /// <summary>
        ///  ֵ 
        /// </summary>
        public Dictionary<ItemData, int> goItemDataRefList = new Dictionary<ItemData, int>();
        /// <summary>
        /// ǰ ѭitem         Ļ  ʱ  洢Ϊ У
        /// </summary>
        public List<List<ItemData>> cellItemList = new List<List<ItemData>>();



        #endregion

        #region SetData

        /// <summary>
        /// ʾеdata 
        /// </summary>
        public int dataCount;

        public Action<int, GameObject> updateFunc;

        /// <summary>
        ///  grid RectTransform ֵ     =  ʱе* һitemĸ߶   -     rtf ؼĸ߶ȡ
        /// </summary>
        public float itemDis;

        /// <summary>
        ///  index ֵ ໬Ǹ index  =  ʱ  ֵ  е - һҳ
        /// </summary>
        public int maxOffset;

        public DGTween tmpTween;

        /// <summary>
        /// ǰ itemindex   0  ʵ- һҳ
        /// Ϊ ͨǰui  dragGOTran ƶλ  ǰڵitem index
        /// </summary>
        public int curDataIndex;

        #endregion


        public ScrollCycleView(Transform uiCanvas, Transform uiParent, DragType type)
        {
             this.Awake(uiCanvas, uiParent, type);
        }


    }
    public static class ScrollCycleViewSystem
    {



        public static void Awake(this ScrollCycleView self,Transform uiCanvas ,Transform tra, DragType type)
        {

            RectTransform trf = tra.GetComponent<RectTransform>();
            RectTransform trfSV = tra.Find("ScrollCycleView").GetComponent<RectTransform>();

            trfSV.anchoredPosition = Vector2.zero;



            Vector3[] arrWorldPos = new Vector3[4];

            float uiScale = uiCanvas.localScale.x;//canvs => unityתıֵ    overlay =1   camra ȡ

            trf.GetWorldCorners(arrWorldPos);

            Vector3 worldSize = arrWorldPos[2] - arrWorldPos[0];

            trfSV.sizeDelta = worldSize / uiScale;




            self.InitComponent(trfSV.gameObject);



            var tmpScrollBar = tra.Find("Scrollbar");
            self.scrollBar = tmpScrollBar != null ? tmpScrollBar.GetComponent<Scrollbar>() : null;

            GridLayoutGroup layout = tra.Find("Layout").GetComponent<GridLayoutGroup>();
            layout.gameObject.SetActive(false);

            self.spacing = layout.spacing;


            self.item = layout.transform.GetChild(0).gameObject;
            self.item.GetComponent<RectTransform>().sizeDelta = layout.cellSize;
            self.item.gameObject.SetActive(true);
            self.dragType = type;
        }

        /// <summary>
        ///  ʼ
        /// </summary>
        /// <param name="self"></param>
        /// <param name="goScroll">Զ̬ goScroll ʾscroll</param>
        public static void InitComponent(this ScrollCycleView self, GameObject goScroll)
        {
            //ϵ
            self.speed = 1;
            self.resistance = 1;
            self.elastic = true;

            self.gameObject = goScroll;
            self.rectTransform = goScroll.transform.GetComponent<RectTransform>();
            self.dragGOTran = self.rectTransform.Find("grid").GetComponent<RectTransform>();

            //
            self.trigger = goScroll.GetComponent<EventTrigger>();
            if (self.trigger == null) self.trigger = goScroll.AddComponent<EventTrigger>();

            self.trigger.RegisterEvent(EventTriggerType.BeginDrag, self.OnBeginDrag);
            self.trigger.RegisterEvent(EventTriggerType.EndDrag, self.OnEndDrag);
            self.trigger.RegisterEvent(EventTriggerType.Drag, self.OnDrag);


            //ƶĶ
            self.moveTween = self.dragGOTran.GetComponent<UITweenSpring>();
            if (self.moveTween == null) self.moveTween = self.dragGOTran.gameObject.AddComponent<UITweenSpring>();
            self.moveTween.enabled = false;
            self.moveTween.OnUpdate = self.UpdatePosition;
            self.moveTween.OnMoveEnd = self.OnMoveEnd;
            self.moveTween.MomentumAmount = self.speed;
            self.moveTween.Strength = self.resistance;

        }
        /// <summary>
        ///  ĬϾ
        /// </summary>
        /// <param name="self"></param>
        /// <param name="fixedCount">ĬԶ </param>
        public static void OnInit(this ScrollCycleView self, int fixedCount = -1)
        {

            self._OnOpen(self.gameObject, self.item, self.rectTransform.sizeDelta, self.dragType, self.spacing, fixedCount, self.scrollBar);
        }


        /// <summary>
        ///   ѭб
        /// </summary>
        /// <param name="self"></param>
        /// <param name="goScroll">Զ̬ goScroll ʾscroll</param>
        /// <param name="itemGO">Ԫ壬êһ㣬</param>
        /// <param name="scrollBar"></param>
        /// <param name="scrollSizeDeltaV2">СһǸڵСһ£</param>
        /// <param name="dragType"> </param>
        /// <param name="fixedCount">ʱÿһ мԪأȻ</param>
        /// <param name="spacingV2">С </param>
        private static void _OnOpen(this ScrollCycleView self, GameObject goScroll, GameObject itemGO, Vector2 scrollSizeDeltaV2, DragType dragType, Vector2 spacingV2, int fixedCount = 1, Scrollbar scrollBar = null)
        {



            //self.InitComponent(goScroll);

            self.item = itemGO;
            self.scrollBar = scrollBar;
            self.rectTransform.sizeDelta = scrollSizeDeltaV2;
            self.dragType = dragType;

            self.spacing = spacingV2;

            self.cellSize = itemGO.GetComponent<RectTransform>().sizeDelta;
            self.itemWidth = self.spacing.x + self.cellSize.x;
            self.itemHeight = self.spacing.y + self.cellSize.y;


            //Զ
            if (fixedCount == -1)
            {
                float len = self.dragType == DragType.Vertical ? self.rectTransform.sizeDelta.x + self.spacing.x : self.rectTransform.sizeDelta.y + self.spacing.y;

                fixedCount = self.dragType == DragType.Vertical ? ((int)(len / self.itemWidth)) : ((int)(len / self.itemHeight));
            }
            self.fixedCount = fixedCount;
            switch (self.dragType)
            {
                case DragType.Vertical:
                    //  ϲ Ϊ׼
                    self.dragGOTran.anchorMin = new Vector2(0.5f, 1f);
                    self.dragGOTran.anchorMax = new Vector2(0.5f, 1f);
                    self.dragGOTran.pivot = new Vector2(0.5f, 1f);
                    //  Ϊ 
                    self.dragGOTran.sizeDelta = new Vector2(self.itemWidth * (self.fixedCount - 1), 0);
                    self.itemCount = Mathf.CeilToInt(scrollSizeDeltaV2.y / self.itemHeight + 1);
                    self.offsetV2 = new Vector2(0f, -self.itemHeight * self.itemCount);

                    break;
                case DragType.Horizontal:


                    self.dragGOTran.anchorMin = new Vector2(0f, 0.5f);
                    self.dragGOTran.anchorMax = new Vector2(0f, 0.5f);
                    self.dragGOTran.pivot = new Vector2(0f, 0.5f);
                    self.dragGOTran.sizeDelta = new Vector2(0f, self.itemHeight * (self.fixedCount - 1));
                    self.itemCount = Mathf.CeilToInt(scrollSizeDeltaV2.x / self.itemWidth + 1);
                    self.offsetV2 = new Vector2(self.itemWidth * self.itemCount, 0f);



                    break;
                default:
                    break;
            }

            self.goItemList.Clear();
            self.goItemDataRefList.Clear();
            self.cellItemList.Clear();

            //ʼ ʾui item 
            for (int j = 0; j < self.fixedCount; j++)
            {
                List<ItemData> itemList = new List<ItemData>();
                for (int i = 0; i < self.itemCount; i++)
                {
                    itemList.Add(new ItemData());
                }
                self.cellItemList.Add(itemList);
            }






        }


        /// <summary>
        ///  Ӧ  ʾ ˢ   
        /// </summary>
        /// <param name="self"></param>
        /// <param name="dataCount"></param>
        /// <param name="updateFunc"></param>
        public static void SetData(this ScrollCycleView self, int dataCount, Action<int, GameObject> updateFunc)
        {
            // reset data
            self.dataCount = dataCount;
            self.updateFunc = updateFunc;
            self.goItemList.Clear();
            self.goItemDataRefList.Clear();



            //     Ӧ    
            int VetiOrHoriTotalNum = Mathf.CeilToInt((float)self.dataCount / self.fixedCount);
            switch (self.dragType)
            {
                case DragType.Vertical:
                    self.itemDis = self.itemHeight * VetiOrHoriTotalNum + self.spacing.y - self.rectTransform.sizeDelta.y;

                    self.maxOffset = Mathf.Max(VetiOrHoriTotalNum - self.itemCount, 0);

                    break;
                case DragType.Horizontal:
                    self.itemDis = self.itemWidth * VetiOrHoriTotalNum + self.spacing.x - self.rectTransform.sizeDelta.x;
                    self.maxOffset = Mathf.Max(VetiOrHoriTotalNum - self.itemCount, 0);

                    break;
                default:
                    break;
            }


            self.SetBackTween();

            int oldIndex = self.curDataIndex;
            Vector2 oldPos = self.dragGOTran.anchoredPosition;

            self.curDataIndex = 0;
            self.SetPosition(Vector2.zero);

            // Ķui
            float leftX = self.spacing.x / 2;
            float upY = self.spacing.y / 2;
            for (int j = 0; j < self.fixedCount; j++)
            {
                for (int i = 0; i < self.itemCount; i++)
                {
                    ItemData item = self.cellItemList[j][i];
                    int index = j + i * self.fixedCount;
                    //
                    if (item.go == null && index < self.dataCount)
                    {
                        GameObject go = GameObject.Instantiate(self.item);
                        go.name = "item" + index;
                        go.transform.SetParent(self.dragGOTran, false);
                        go.transform.localPosition = Vector3.zero;
                        go.SetActive(false);

                        RectTransform tran = go.GetComponent<RectTransform>();
                        tran.anchorMin = new Vector2(0, 1);
                        tran.anchorMax = new Vector2(0, 1);

                        item.go = go;
                        item.tran = tran;
                    }

                    // ʼλ 
                    if (item.go != null)
                    {
                        switch (self.dragType)
                        {
                            case DragType.Vertical:

                                item.tran.anchoredPosition = new Vector2(self.itemWidth * j, (0.5f - i - 1) * self.itemHeight + upY);
                                break;
                            case DragType.Horizontal:

                                item.tran.anchoredPosition = new Vector2((i + 0.5f) * self.itemWidth - leftX, -self.itemHeight * j);
                                break;
                            default:
                                break;
                        }



                        self.goItemList.Add(item.go);
                    }

                    self.SetUpdate(index, item);
                }
            }
            // scrollBar
            if (self.scrollBar != null)
            {
                //  ʼҳܳռȣó ĳߴ磨һҳܳı
                switch (self.dragType)
                {
                    case DragType.Vertical:
                        //óʼ һҳռ ܳҳitem* itemHeight ȥһitemļΪܳ  ١
                        self.scrollBar.size = self.rectTransform.sizeDelta.y / (self.itemHeight * Mathf.CeilToInt((float)dataCount / self.fixedCount) + self.spacing.y);
                        break;
                    case DragType.Horizontal:

                        self.scrollBar.size = self.rectTransform.sizeDelta.x / (self.itemWidth * Mathf.CeilToInt((float)dataCount / self.fixedCount) + self.spacing.x);
                        break;
                    default:
                        break;
                }

                // ǰλõ scrollbar ڵ 
                if (oldIndex == 0)
                {
                    self.scrollBar.value = 0;
                }
                else
                {
                    switch (self.dragType)
                    {
                        case DragType.Vertical:

                            self.scrollBar.value = oldPos.y / self.itemDis;
                            break;
                        case DragType.Horizontal:

                            self.scrollBar.value = -oldPos.x / self.itemDis;
                            break;
                        default:
                            break;
                    }

                }


                self.scrollBar.onValueChanged.AddListener((f) =>
                {
                    //if (self.scrollBar.value <= 0 && f < 0) return;
                    //if (self.scrollBar.value >= 1 && f > 0) return;
                    Vector2 v2 = Vector2.zero;
                    int curIndex = 0;


                    switch (self.dragType)
                    {
                        case DragType.Vertical:

                            v2 = Vector2.Lerp(Vector2.zero, new Vector2(0, self.itemDis), f);
                            curIndex = Mathf.FloorToInt(v2.y / self.itemHeight);
                            break;
                        case DragType.Horizontal:

                            v2 = Vector2.Lerp(Vector2.zero, new Vector2(-self.itemDis, 0), f);
                            curIndex = Mathf.FloorToInt(-v2.x / self.itemWidth);
                            break;
                        default:
                            break;
                    }

                    self.SetPosition(v2);
                    self.SetItemIndex(curIndex);
                });
            }


            // ֮ǰλ 
            if (oldIndex != 0)
            {
                if (self.itemDis > 0)
                {

                    switch (self.dragType)
                    {
                        case DragType.Vertical:

                            self.SetPosition(new Vector2(0, Mathf.Clamp(oldPos.y, 0, self.itemDis)));
                            break;
                        case DragType.Horizontal:

                            self.SetPosition(new Vector2(Mathf.Clamp(oldPos.x, -self.itemDis, 0), 0));
                            break;
                        default:
                            break;
                    }

                }
                self.SetItemIndex(oldIndex);
            }
        }






        //--õǰλϲ㣬duration > 0, 򲥷Ŷָλ, ƶָλãڻ  ƫ⣩

        public static void SetIndex(this ScrollCycleView self, int curIndex = 0, float duration = 0, EaseType easeType = EaseType.Normal)
        {
            int itemOffset = Mathf.CeilToInt((float)curIndex / self.fixedCount) - 1;

            if (self.itemDis > 0)//Ƿ ܹҳ ܹҳ Ҫ idex
            {
                Vector2 av2 = self.dragGOTran.anchoredPosition;
                Vector2 mv2 = Vector2.zero;
                switch (self.dragType)
                {
                    case DragType.Vertical:
                        mv2 = new Vector2(0, Mathf.Clamp(self.itemHeight * itemOffset, 0, self.itemDis));
                        break;
                    case DragType.Horizontal:
                        mv2 = new Vector2(Mathf.Clamp(-self.itemWidth * itemOffset, -self.itemDis, 0), 0);
                        break;
                    default:
                        break;
                }



                if (duration > 0)
                {

                    DOTweenAnimCurve.Instance.To(0, 1, duration, progress =>
                    {
                        self.SetPosition(Vector2.Lerp(av2, mv2, progress));

                        int curIndexTmp;

                        switch (self.dragType)
                        {
                            case DragType.Vertical:
                                curIndexTmp = Mathf.FloorToInt(self.dragGOTran.anchoredPosition.y / self.itemHeight);
                                break;
                            case DragType.Horizontal:
                                curIndexTmp = Mathf.FloorToInt(-self.dragGOTran.anchoredPosition.x / self.itemWidth);
                                break;
                            default:
                                curIndexTmp = 0;
                                break;
                        }


                        self.SetItemIndex(curIndexTmp);

                        switch (self.dragType)
                        {
                            case DragType.Vertical:

                                if (self.scrollBar != null)
                                {
                                    self.scrollBar.value = self.dragGOTran.anchoredPosition.y / self.itemDis;
                                }
                                break;
                            case DragType.Horizontal:

                                if (self.scrollBar != null)
                                {
                                    self.scrollBar.value = -self.dragGOTran.anchoredPosition.x / self.itemDis;
                                }
                                break;
                            default:
                                break;
                        }


                    }).OnStart(() =>
                    {
                        self.trigger.enabled = false;
                    }).OnComplete(() =>
                    {
                        self.trigger.enabled = true;
                    }); ;


                }
                else
                {
                    if (self.curDataIndex > 0)//--ʼΪ0
                    {
                        foreach (var kvp in self.goItemDataRefList)//--⵽ڿл¼ԭλãлλù̶
                        {
                            if (kvp.Value == curIndex)
                            {
                                Vector2 kv2 = kvp.Key.tran.anchoredPosition + av2;
                                bool b = false;


                                switch (self.dragType)
                                {
                                    case DragType.Vertical:
                                        b = kv2.y > -self.rectTransform.sizeDelta.y - self.cellSize.y / 2 && kv2.y < self.cellSize.y / 2;
                                        break;
                                    case DragType.Horizontal:
                                        b = kv2.x > -self.cellSize.x / 2 && kv2.x < self.rectTransform.sizeDelta.x + self.cellSize.x / 2;
                                        break;
                                    default:
                                        break;
                                }

                                if (b)
                                {
                                    mv2 = av2;
                                    itemOffset = self.curDataIndex;
                                }
                                break;
                            }
                        }
                    }
                    self.SetPosition(mv2);




                    self.SetItemIndex(itemOffset);


                    switch (self.dragType)
                    {
                        case DragType.Vertical:

                            if (self.scrollBar != null)
                            {
                                self.scrollBar.value = self.dragGOTran.anchoredPosition.y / self.itemDis;
                            }
                            break;
                        case DragType.Horizontal:

                            if (self.scrollBar != null)
                            {
                                self.scrollBar.value = -self.dragGOTran.anchoredPosition.x / self.itemDis;
                            }
                            break;
                        default:
                            break;
                    }
                }
            }
            else
            {

                self.SetPosition(Vector2.zero);
                self.SetItemIndex(0);
                if (self.scrollBar != null)
                {
                    self.scrollBar.value = 1;
                }
            }

        }


        /// <summary>
        /// õ嵱ǰбеidx 
        /// </summary>
        /// <param name="self"></param>
        /// <param name="go"></param>
        /// <returns></returns>
        public static int GetItemDataIndex(this ScrollCycleView self, GameObject go)
        {
            foreach (var kvp in self.goItemDataRefList)
            {
                if (kvp.Key.go == go)
                {
                    return kvp.Value;
                }
            }

            return -1; // ûҵƥԸ󷵻ʵĬֵ
        }


        #region trigger ¼
        private static void OnBeginDrag(this ScrollCycleView self, BaseEventData data)
        {

            if (self.dataCount <= 0) return;
            self.SetBackTween(self.tmpTween);
            self.moveTween.enabled = true;
            self.moveTween.Momentum = Vector3.zero;
            self.moveTween.IsUseCallBack = false;
            self.moveTween.Strength = self.resistance;
            data.Use();
        }



        private static void OnDrag(this ScrollCycleView self, BaseEventData data)
        {

            if (self.dataCount <= 0) return;
            PointerEventData ped = data as PointerEventData;
            self.moveTween.LerpMomentum(ped.delta);
            self.UpdatePosition(ped.delta * self.speed);
            data.Use();
        }


        private static void OnEndDrag(this ScrollCycleView self, BaseEventData data)
        {

            if (self.dataCount <= 0) return;
            if (self.itemDis >= 0)
            {
                self.moveTween.IsUseCallBack = true;
            }
            else
            {
                self.OnMoveEnd();
            }
            data.Use();
        }

        private static void RegisterEvent(this EventTrigger trigger, EventTriggerType eventType, UnityAction<BaseEventData> callback, bool isRemoveAllEvent = true)
        {
            EventTrigger.Entry entry = null;
            bool isHas = false;
            // ǷѾҪע¼
            foreach (EventTrigger.Entry existingEntry in trigger.triggers)
            {
                if (existingEntry.eventID == eventType)
                {
                    entry = existingEntry;
                    isHas = true;
                    break;
                }
            }

            // ¼ڣʹµʵ
            if (entry == null)
            {
                entry = new EventTrigger.Entry();
                entry.eventID = eventType;
            }
            if (isRemoveAllEvent)
                entry.callback.RemoveAllListeners();
            // Ӵصע¼
            entry.callback.AddListener(callback);
            if (!isHas)
                trigger.triggers.Add(entry);
        }

        #endregion


        #region ƶ 
        /// <summary>
        ///  קĻ  λ 
        /// </summary>
        /// <param name="self"></param>
        /// <param name="dv2">󶨵 OnDrag  ÿһ֡ ƶľ </param>
        private static void UpdatePosition(this ScrollCycleView self, Vector2 dv2)
        {


            Vector2 av2 = self.dragGOTran.anchoredPosition;
            //     ƶ Ϊ0 . 򻬶ͬ
            switch (self.dragType)
            {
                case DragType.Vertical:
                    dv2.x = 0;
                    break;
                case DragType.Horizontal:
                    dv2.y = 0;
                    break;
                default:
                    break;
            }
            Vector2 fv2 = av2 + dv2;
            // ק    ѻֵ ޶ڿɻ
            if (!self.elastic)
            {
                //ɻ
                if (self.itemDis > 0)
                {

                    switch (self.dragType)
                    {
                        case DragType.Vertical:
                            if (fv2.y < 0 || fv2.y > self.itemDis)
                            {
                                fv2.y = Mathf.Clamp(fv2.y, 0, self.itemDis);
                            }
                            break;
                        case DragType.Horizontal:
                            if (fv2.x > 0 || fv2.x < -self.itemDis)
                            {
                                fv2.x = Mathf.Clamp(fv2.x, -self.itemDis, 0);
                            }
                            break;
                        default:
                            break;
                    }

                }
                else
                {
                    fv2 = Vector2.zero;
                }
            }//Ĵ  Ƿ񳬿 ڻ  ӳ  ʱΪԼ0ֱӵ OnMoveEnd Żص
            else
            {
                if (self.itemDis > 0)
                {
                    bool isOutRange = false;
                    switch (self.dragType)
                    {
                        case DragType.Vertical:
                            isOutRange = (fv2.y < 0 && self.curDataIndex == 0) || (fv2.y > self.itemDis && self.curDataIndex == self.maxOffset);
                            break;
                        case DragType.Horizontal:
                            isOutRange = (fv2.x > 0 && self.curDataIndex == 0) || (fv2.x < -self.itemDis && self.curDataIndex == self.maxOffset);
                            break;
                        default:
                            break;
                    }


                    if (isOutRange)
                    {
                        self.moveTween.Strength = 999;
                    }
                }
            }
            self.SetPosition(fv2);


            int curIndex = 0;

            switch (self.dragType)
            {
                case DragType.Vertical:
                    curIndex = Mathf.FloorToInt(self.dragGOTran.anchoredPosition.y / self.itemHeight);
                    if (self.scrollBar != null)
                    {
                        self.scrollBar.value = self.dragGOTran.anchoredPosition.y / self.itemDis;
                    }
                    break;
                case DragType.Horizontal:
                    curIndex = Mathf.FloorToInt(-self.dragGOTran.anchoredPosition.x / self.itemWidth);
                    if (self.scrollBar != null)
                    {
                        self.scrollBar.value = -self.dragGOTran.anchoredPosition.x / self.itemDis;
                    }
                    break;
                default:
                    break;
            }

            self.SetItemIndex(curIndex);
        }

        private static void OnMoveEnd(this ScrollCycleView self)
        {
            Vector2 fv2 = self.dragGOTran.anchoredPosition;


            switch (self.dragType)
            {
                case DragType.Vertical:

                    if (self.itemDis < 0)
                    {

                        self.SetBackTween(DOTweenAnimCurve.Instance.DOAnchorPosY(self.dragGOTran, 0, 0.3f));
                    }
                    else
                    {
                        if (fv2.y < 0 && self.curDataIndex == 0)
                        {
                            self.SetBackTween(DOTweenAnimCurve.Instance.DOAnchorPosY(self.dragGOTran, 0, 0.3f));
                        }
                        else if (fv2.y > self.itemDis && self.curDataIndex == self.maxOffset)
                        {
                            self.SetBackTween(DOTweenAnimCurve.Instance.DOAnchorPosY(self.dragGOTran, self.itemDis, 0.3f));

                        }
                    }

                    break;
                case DragType.Horizontal:


                    if (self.itemDis < 0)
                    {
                        self.SetBackTween(DOTweenAnimCurve.Instance.DOAnchorPosX(self.dragGOTran, 0, 0.3f));

                    }
                    else
                    {
                        if (fv2.x > 0 && self.curDataIndex == 0)
                        {
                            self.SetBackTween(DOTweenAnimCurve.Instance.DOAnchorPosX(self.dragGOTran, 0, 0.3f));
                        }
                        else if (fv2.x < -self.itemDis && self.curDataIndex == self.maxOffset)
                        {
                            self.SetBackTween(DOTweenAnimCurve.Instance.DOAnchorPosX(self.dragGOTran, -self.itemDis, 0.3f));

                        }
                    }

                    break;
                default:
                    break;
            }

        }




        /// <summary>
        ///  Ķ
        /// </summary>
        /// <param name="self"></param>
        /// <param name="tween"></param>
        private static void SetBackTween(this ScrollCycleView self, DGTween tween = null)
        {
            if (self.tmpTween != null)
            {
                DOTweenAnimCurve.Instance.KillAnimCurve(self.tmpTween);
                self.tmpTween = null;
            }

            self.tmpTween = tween;

        }

        /// <summary>
        ///   λ
        /// </summary>
        /// <param name="self"></param>
        /// <param name="v2"></param>
        private static void SetPosition(this ScrollCycleView self, Vector2 v2)
        {

            self.dragGOTran.anchoredPosition = v2;

        }
        /// <summary>
        ///  ĳitemļϢԼص
        /// </summary>
        /// <param name="self"></param>
        /// <param name="index">ĳitem idex</param>
        /// <param name="item"></param>
        private static void SetUpdate(this ScrollCycleView self, int index, ItemData item)
        {
            if (index < self.dataCount)
            {
                //ü 
                if (!item.isActive)
                {
                    item.isActive = true;
                    item.go.SetActive(true);
                }
                //ص
                self.updateFunc(index, item.go);
                if (self.goItemDataRefList.ContainsKey(item))
                    self.goItemDataRefList[item] = index;
                else
                {
                    self.goItemDataRefList.Add(item, index);
                }
            }
            else
            {
                if (item.isActive)
                {
                    item.isActive = false;
                    item.go.SetActive(false);
                }
            }
        }




        /// <summary>
        ///  item λ Լ Ϣ
        /// </summary>
        /// <param name="self"></param>
        /// <param name="curIndex">ǰ itemindex()</param>
        private static void SetItemIndex(this ScrollCycleView self, int curIndex)
        {
            curIndex = Math.Clamp(curIndex, 0, self.maxOffset);
            if (curIndex != self.curDataIndex)
            {
                self.ItemListOffset(curIndex - self.curDataIndex);

                self.curDataIndex = curIndex;
            }



        }
        // lua    -1%10 = 9  .C#  -1%10 = -1  C#ģ lua -1%10 = -1%10+10 
        private static int Modulo(int dividend, int divisor)
        {
            int remainder = dividend % divisor;
            return remainder < 0 ? remainder + divisor : remainder;
        }
        /// <summary>
        ///  ƶ cellItemList ڵ  
        /// </summary>
        /// <param name="self"></param>
        /// <param name="list"></param>
        /// <param name="k"></param>
        private static void Move(this ScrollCycleView self, List<ItemData> list, int k)
        {

            k = Modulo(k, list.Count);

            if (k == 0)
                return;
            int endIdx = list.Count - 1;
            //ת ƫƵ Ǽ
            self.Reverse(list, 0, endIdx - k);
            //ת  Ǽ
            self.Reverse(list, list.Count - k, endIdx);
            //巴ת
            self.Reverse(list, 0, endIdx);
        }

        private static void Reverse(this ScrollCycleView self, List<ItemData> list, int start, int end)
        {
            while (start < end)
            {
                ItemData temp = list[start];
                list[start] = list[end];
                list[end] = temp;
                start++;
                end--;
            }
        }
        private static void ItemListOffset(this ScrollCycleView self, int offset)
        {
            int curNewDataIdx, offsetPage, offsetSomeOne, curChangeOffsetPage, showIdx, itemNextPage;
            ItemData item;

            //ҳǼ itemҪ 

            //ʱ ƫ˶ҳһҳҪٸitem/ٸItemóڼҳ
            offsetPage = Mathf.FloorToInt(Mathf.Abs(offset) / self.itemCount);
            //ʱƫ˵ڼ     1
            offsetSomeOne = Mathf.Abs(offset) % self.itemCount;

            if (offset > 0)
            {
                //uiƶ
                for (int j = 0; j < self.fixedCount; j++)
                {
                    for (int i = 0; i < self.itemCount; i++)
                    {
                        //ǰitemǷ һҳ      
                        itemNextPage = (i + 1) <= offsetSomeOne ? 1 : 0;

                        curChangeOffsetPage = itemNextPage + offsetPage;
                        if (curChangeOffsetPage > 0)//Ǽ itemҪƶ ĳitem´ƶλã+xҳĵǰλã
                        {

                            // ǰ item ıĶҳ * һҳе + ֮ǰʵڵ  +  itemŵ = ǰԼ index
                            curNewDataIdx = self.itemCount * curChangeOffsetPage + self.curDataIndex + i;
                            //ʾľidx  jʾڼУ + hang* һжٸ   =  ǰڵһ* +ǰŵڼ 
                            showIdx = curNewDataIdx * self.fixedCount + j;

                            //
                            item = self.cellItemList[j][i];
                            //itemǰλ = ǰλ+ ƶ˶ҳ ֵ
                            item.tran.anchoredPosition += self.offsetV2 * curChangeOffsetPage;


                            self.SetUpdate(showIdx, item);
                        }
                    }
                    //data  ui 䶯
                    self.Move(self.cellItemList[j], -offset);
                }
            }  //ʱ   
            else//ʱ   //ʱ   
            {
                for (int j = self.fixedCount - 1; j >= 0; --j)
                {
                    for (int i = self.itemCount - 1; i >= 0; --i)
                    {
                        //ǰitemǷ һҳ      
                        itemNextPage = (i + 1) > (self.itemCount - offsetSomeOne) ? 1 : 0;

                        curChangeOffsetPage = itemNextPage + offsetPage;
                        if (curChangeOffsetPage > 0)
                        {
                            //ǰ ڵidx  
                            curNewDataIdx = self.curDataIndex + i - self.itemCount * curChangeOffsetPage;
                            //ʾidx = 
                            showIdx = curNewDataIdx * self.fixedCount + j;


                            item = self.cellItemList[j][i];
                            item.tran.anchoredPosition -= self.offsetV2 * curChangeOffsetPage;

                            self.SetUpdate(showIdx, item);
                        }
                    }
                    //data  ui 䶯
                    self.Move(self.cellItemList[j], -offset);
                }


            }


        }

















        #endregion



    }


}
